--- db_input.php.orig	2010-02-08 22:46:00.000000000 +0000
+++ db_input.php	2010-03-06 11:18:00.000000000 +0000
@@ -192,11 +192,12 @@
         $password = addslashes($_POST['alb_password']);
                 $password_hint = addslashes(trim($_POST['alb_password_hint']));
         $visibility = !empty($password) ? FIRST_USER_CAT + USER_ID : $visibility;
+        $moderator_group = (int)$_POST['moderator_group'];
 
         if (!$title) cpg_die(ERROR, $lang_db_input_php['alb_need_title'], __FILE__, __LINE__);
 
         if (GALLERY_ADMIN_MODE) {
-            $query = "UPDATE {$CONFIG['TABLE_ALBUMS']} SET title='$title', description='$description', category='$category', thumb='$thumb', uploads='$uploads', comments='$comments', votes='$votes', visibility='$visibility', alb_password='$password', alb_password_hint='$password_hint', keyword='$keyword' WHERE aid='$aid' LIMIT 1";
+            $query = "UPDATE {$CONFIG['TABLE_ALBUMS']} SET title='$title', description='$description', category='$category', thumb='$thumb', uploads='$uploads', comments='$comments', votes='$votes', visibility='$visibility', alb_password='$password', alb_password_hint='$password_hint', keyword='$keyword', moderator_group='$moderator_group' WHERE aid='$aid' LIMIT 1";
         } else {
             $category = FIRST_USER_CAT + USER_ID;
             $query = "UPDATE {$CONFIG['TABLE_ALBUMS']} SET title='$title', description='$description', thumb='$thumb',  comments='$comments', votes='$votes', visibility='$visibility', alb_password='$password', alb_password_hint='$password_hint',keyword='$keyword' WHERE aid='$aid' AND category='$category' LIMIT 1";
--- editpics.php.orig	2010-02-08 22:46:00.000000000 +0000
+++ editpics.php	2010-03-06 10:43:00.000000000 +0000
@@ -20,9 +20,25 @@
 define('IN_COPPERMINE', true);
 define('EDITPICS_PHP', true);
 
-require('include/init.inc.php');
+require('include/init.inc.php');
 
-if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE)) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
+if (is_array($USER_DATA['allowed_albums']) && count($USER_DATA['allowed_albums'])) {
+
+    define('MODERATOR_MODE', 1);
+    $albStr = implode(",", $USER_DATA['allowed_albums']);
+    $albStr = "($albStr)";
+
+    if (isset($_REQUEST['album']) && in_array($_REQUEST['album'], $USER_DATA['allowed_albums'])) {
+      define('MODERATOR_EDIT_MODE', 1);
+    } else {
+      define('MODERATOR_EDIT_MODE', 0);
+    }
+} else {
+    define('MODERATOR_MODE', 0);
+    define('MODERATOR_EDIT_MODE', 0);
+}
+
+if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE || MODERATOR_MODE)) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
 
 define('UPLOAD_APPROVAL_MODE', isset($_GET['mode']));
 define('EDIT_PICTURES_MODE', !isset($_GET['mode']));
@@ -35,7 +51,7 @@
         $album_id = -1;
 }
 
-if (UPLOAD_APPROVAL_MODE && !GALLERY_ADMIN_MODE) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
+if (UPLOAD_APPROVAL_MODE && !GALLERY_ADMIN_MODE && !MODERATOR_MODE) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
 
 if (EDIT_PICTURES_MODE) {
     $result = cpg_db_query("SELECT title, category FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid = '$album_id'");
@@ -44,7 +60,7 @@
         mysql_free_result($result);
         $cat = $ALBUM_DATA['category'];
         $actual_cat = $cat;
-        if ($cat != FIRST_USER_CAT + USER_ID && !GALLERY_ADMIN_MODE) cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
+        if ($cat != FIRST_USER_CAT + USER_ID && !GALLERY_ADMIN_MODE && !MODERATOR_EDIT_MODE) cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
 } else {
         $ALBUM_DATA = array();
 }
@@ -125,7 +141,7 @@
                 $pic = mysql_fetch_array($result);
                 mysql_free_result($result);
 
-                if (!GALLERY_ADMIN_MODE) {
+                if (!GALLERY_ADMIN_MODE && !MODERATOR_MODE) {
                         if ($pic['category'] != FIRST_USER_CAT + USER_ID) cpg_die(ERROR, $lang_errors['perm_denied']."<br />(picture category = {$pic['category']}/ $pid)", __FILE__, __LINE__);
                         if (!isset($user_album_set[$aid])) cpg_die(ERROR, $lang_errors['perm_denied']."<br />(target album = $aid)", __FILE__, __LINE__);
                 }
@@ -395,7 +411,7 @@
 }
 
 function get_user_albums($user_id = '') {
-        global $CONFIG, $user_albums_list;
+        global $CONFIG, $user_albums_list, $albStr;
 
         $USER_ALBUMS_ARRAY=array(0 => array());
         $or = '';
@@ -405,7 +421,11 @@
         }
 
         if (!isset($USER_ALBUMS_ARRAY[USER_ID])) {
-                $user_albums = cpg_db_query("SELECT aid, title FROM {$CONFIG['TABLE_ALBUMS']} WHERE category='".(FIRST_USER_CAT + USER_ID)."' $or ORDER BY title");
+				if (MODERATOR_MODE && UPLOAD_APPROVAL_MODE || MODERATOR_EDIT_MODE) {
+					$user_albums = cpg_db_query("SELECT aid, title FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid IN $albStr AND category > '".FIRST_USER_CAT."' OR category='".(FIRST_USER_CAT + USER_ID)."' ORDER BY title");
+				} else {
+                	$user_albums = cpg_db_query("SELECT aid, title FROM {$CONFIG['TABLE_ALBUMS']} WHERE category='".(FIRST_USER_CAT + USER_ID)."' $or ORDER BY title");
+                }
 
                 if (mysql_num_rows($user_albums)) {
                     $user_albums_list=cpg_db_fetch_rowset($user_albums);
@@ -420,8 +440,9 @@
 }
 
 
-if (GALLERY_ADMIN_MODE) {
-    $public_albums = cpg_db_query("SELECT DISTINCT aid, title, IF(category = 0, CONCAT('&gt; ', title), CONCAT(name,' &lt; ',title)) AS cat_title FROM {$CONFIG['TABLE_ALBUMS']}, {$CONFIG['TABLE_CATEGORIES']} WHERE category < '" . FIRST_USER_CAT . "' AND (category = 0 OR category = cid) ORDER BY cat_title");
+if (GALLERY_ADMIN_MODE || MODERATOR_MODE) {
+	$where_aid = MODERATOR_MODE? "aid IN $albStr AND" : '';
+    $public_albums = cpg_db_query("SELECT DISTINCT aid, title, IF(category = 0, CONCAT('&gt; ', title), CONCAT(name,' &lt; ',title)) AS cat_title FROM {$CONFIG['TABLE_ALBUMS']}, {$CONFIG['TABLE_CATEGORIES']} WHERE $where_aid category < '" . FIRST_USER_CAT . "' AND (category = 0 OR category = cid) ORDER BY cat_title");
         if (mysql_num_rows($public_albums)) {
             $public_albums_list=cpg_db_fetch_rowset($public_albums);
         } else {
@@ -445,7 +466,11 @@
 $s100 = $count == 100 ? 'selected' : '';
 
 if (UPLOAD_APPROVAL_MODE) {
-        $result=cpg_db_query("SELECT count(*) FROM {$CONFIG['TABLE_PICTURES']} WHERE approved = 'NO'");
+        if (MODERATOR_MODE) {
+            $result=cpg_db_query("SELECT count(*) FROM {$CONFIG['TABLE_PICTURES']} WHERE approved = 'NO' AND aid IN $albStr");
+        } else {
+	        $result=cpg_db_query("SELECT count(*) FROM {$CONFIG['TABLE_PICTURES']} WHERE approved = 'NO'");
+	    }
         $nbEnr = mysql_fetch_array($result);
         $pic_count = $nbEnr[0];
 
@@ -474,11 +499,19 @@
         }
         mysql_free_result($result);
 
-    $sql =  "SELECT * ".
+            if (MODERATOR_MODE) {
+            	$sql =  "SELECT * ".
+                        "FROM {$CONFIG['TABLE_PICTURES']} ".
+                        "WHERE approved = 'NO' AND aid IN $albStr".
+                        "ORDER BY pid ".
+                        "LIMIT $start, $count";
+		    } else {
+				$sql =  "SELECT * ".
                         "FROM {$CONFIG['TABLE_PICTURES']} ".
                         "WHERE approved = 'NO' ".
                         "ORDER BY pid ".
-                        "LIMIT $start, $count";
+                        "LIMIT $start, $count";
+			}
         $result = cpg_db_query($sql);
         $form_target = $_SERVER['PHP_SELF'].'?mode=upload_approval&amp;start='.$start.'&amp;count='.$count;
         $title = $lang_editpics_php['upl_approval'];
--- index.php.orig	2010-02-08 22:46:00.000000000 +0000
+++ index.php	2010-03-06 10:43:00.000000000 +0000
@@ -21,6 +21,49 @@
 * Unless this is true most things wont work - protection against direct execution of inc files
 */
 define('IN_COPPERMINE', true);
+
+/**
+ * html_albummenu2()
+ *
+ * This function draws the links for moderator menu of Albums
+ *
+ * @param integer $id ID of the album for which the links are being drawn
+ * @return string The evaluated template block with links
+ **/
+function html_albummenu2($id) {
+    global $lang_album_admin_menu;
+
+    /**
+     * This template variable can be defined in theme.php of respective theme.
+     * This is done here for simplicity.
+     */    
+    $template_album_moderator_menu = <<<EOT
+        <table border="0" cellpadding="0" cellspacing="1">
+                <tr>
+                        <td align="center" valign="middle" class="admin_menu">
+                                <a href="editpics.php?album={ALBUM_ID}"  class="adm_menu">{EDIT_PICS}</a>
+                        </td>
+                </tr>
+        </table>                        
+EOT;
+    
+    
+    static $template = '';
+
+    if ($template == '') {
+        $params = array(
+            '{EDIT_PICS}' => $lang_album_admin_menu['edit_pics'],
+            );
+
+        $template = template_eval($template_album_moderator_menu, $params);
+    }
+
+    $params = array('{ALBUM_ID}' => $id,
+        );
+
+    return template_eval($template, $params);  
+}
+
 
 if (isset($_GET['file'])) {
     // Scrub: Remove '..' and leftover '//' from filename
@@ -526,7 +569,7 @@
             $alb_list[$alb_idx]['last_upl'] = $last_upload_date;
             $alb_list[$alb_idx]['link_pic_count'] = $link_pic_count;
             $alb_list[$alb_idx]['album_info'] = sprintf($lang_list_albums['n_pictures'], $count) . ($count ? sprintf($lang_list_albums['last_added'], $last_upload_date) : "") . (($CONFIG['link_pic_count'] && $link_pic_count > 0 ) ? sprintf(", {$lang_list_albums['n_link_pictures']},  {$lang_list_albums['total_pictures']}", $link_pic_count, $count + $link_pic_count) : "");
-            $alb_list[$alb_idx]['album_adm_menu'] = (GALLERY_ADMIN_MODE || (USER_ADMIN_MODE && $cat == USER_ID + FIRST_USER_CAT)) ? html_albummenu($alb_thumb['aid']) : ' ';
+            $alb_list[$alb_idx]['album_adm_menu'] = (GALLERY_ADMIN_MODE || (USER_ADMIN_MODE && $cat == USER_ID + FIRST_USER_CAT)) ? html_albummenu($alb_thumb['aid']) : (in_array($alb_thumb['aid'], $USER_DATA['allowed_albums']) ? html_albummenu2($alb_thumb['aid']) : '');
         } elseif ($CONFIG['show_private']) { // uncomment this else block to show private album description
             $last_upload_date = $count ? localised_date($alb_stat['last_upload'], $lastup_date_fmt) : '';
             $link_pic_count = !empty($alb_stat['link_pic_count']) ? $alb_stat['link_pic_count'] : 0;
@@ -537,7 +580,7 @@
             $alb_list[$alb_idx]['last_upl'] = $last_upload_date;
             $alb_list[$alb_idx]['link_pic_count'] = $link_pic_count;
             $alb_list[$alb_idx]['album_info'] = sprintf($lang_list_albums['n_pictures'], $count) . ($count ? sprintf($lang_list_albums['last_added'], $last_upload_date) : "") . (($CONFIG['link_pic_count'] && $link_pic_count > 0 ) ? sprintf(", {$lang_list_albums['n_link_pictures']},   {$lang_list_albums['total_pictures']}", $link_pic_count, $count + $link_pic_count) : "");
-            $alb_list[$alb_idx]['album_adm_menu'] = (GALLERY_ADMIN_MODE || (USER_ADMIN_MODE && $cat == USER_ID + FIRST_USER_CAT)) ? html_albummenu($alb_thumb['aid']) : ' ';
+            $alb_list[$alb_idx]['album_adm_menu'] = (GALLERY_ADMIN_MODE || (USER_ADMIN_MODE && $cat == USER_ID + FIRST_USER_CAT)) ? html_albummenu($alb_thumb['aid']) : (in_array($alb_thumb['aid'], $USER_DATA['allowed_albums']) ? html_albummenu2($alb_thumb['aid']) : '');
         }
     }
 
@@ -685,7 +728,7 @@
             $alb_list[$alb_idx]['pic_count'] = $count;
             $alb_list[$alb_idx]['last_upl'] = $last_upload_date;
             $alb_list[$alb_idx]['album_info'] = sprintf($lang_list_albums['n_pictures'], $count) . ($count ? sprintf($lang_list_albums['last_added'], $last_upload_date) : "") . (($CONFIG['link_pic_count'] && $link_pic_count > 0)  ? sprintf(", {$lang_list_albums['n_link_pictures']}, {$lang_list_albums['total_pictures']}", $link_pic_count, $count + $link_pic_count) : "");
-            $alb_list[$alb_idx]['album_adm_menu'] = (GALLERY_ADMIN_MODE || (USER_ADMIN_MODE && $cat == USER_ID + FIRST_USER_CAT)) ? html_albummenu($alb_thumb['aid']) : '';
+            $alb_list[$alb_idx]['album_adm_menu'] = (GALLERY_ADMIN_MODE || (USER_ADMIN_MODE && $cat == USER_ID + FIRST_USER_CAT)) ? html_albummenu($alb_thumb['aid']) : (in_array($alb_thumb['aid'], $USER_DATA['allowed_albums']) ? html_albummenu2($alb_thumb['aid']) : '');
         } elseif ($CONFIG['show_private']) { // uncomment this else block to show private album description
             $last_upload_date = $count ? localised_date($alb_stat['last_upload'], $lastup_date_fmt) : '';
             $link_pic_count = !empty($alb_stat['link_pic_count']) ? $alb_stat['link_pic_count'] : 0;
@@ -695,7 +738,7 @@
             $alb_list[$alb_idx]['pic_count'] = $count;
             $alb_list[$alb_idx]['last_upl'] = $last_upload_date;
             $alb_list[$alb_idx]['album_info'] = sprintf($lang_list_albums['n_pictures'], $count) . ($count ? sprintf($lang_list_albums['last_added'], $last_upload_date) : "") . (($CONFIG['link_pic_count'] && $link_pic_count > 0 )? sprintf(", {$lang_list_albums['n_link_pictures']}, {$lang_list_albums['total_pictures']}", $link_pic_count, $count + $link_pic_count) : "");
-            $alb_list[$alb_idx]['album_adm_menu'] = (GALLERY_ADMIN_MODE || (USER_ADMIN_MODE && $cat == USER_ID + FIRST_USER_CAT)) ? html_albummenu($alb_thumb['aid']) : '';
+            $alb_list[$alb_idx]['album_adm_menu'] = (GALLERY_ADMIN_MODE || (USER_ADMIN_MODE && $cat == USER_ID + FIRST_USER_CAT)) ? html_albummenu($alb_thumb['aid']) : (in_array($alb_thumb['aid'], $USER_DATA['allowed_albums']) ? html_albummenu2($alb_thumb['aid']) : '');
         }
     }
     ob_start();
--- modifyalb.php.orig	2010-02-08 22:46:00.000000000 +0000
+++ modifyalb.php	2010-03-06 10:48:00.000000000 +0000
@@ -53,6 +53,10 @@
     array($lang_modifyalb_php['can_post_comments'].$notice1, 'comments', 1),
     array($lang_modifyalb_php['can_rate'].$notice1, 'votes', 1),
     );
+
+if (GALLERY_ADMIN_MODE) {
+	$data[] = array($lang_modifyalb_php['can_moderate'], 'moderator_group', 8);
+}
 
 function get_subcat_data($parent, $ident = '')
 {
@@ -378,6 +382,34 @@
 
 EOT;
 }
+
+function form_moderator($text, $name) {
+    global $CONFIG,$ALBUM_DATA,$lang_modifyalb_php;
+    $result = cpg_db_query("SELECT group_id, group_name FROM {$CONFIG['TABLE_USERGROUPS']} WHERE group_id > 1");
+    $options[0] = $lang_modifyalb_php['none'];
+    while ($group = mysql_fetch_array($result)) {
+        $options[$group['group_id']] = sprintf($lang_modifyalb_php['groupp_only'], $group['group_name']);
+    } // while
+
+    echo <<<EOT
+        <tr>
+                <td class="tableb">
+                        $text
+                </td>
+                <td class="tableb" valign="top">
+                        <select name="$name" class="listbox">
+
+EOT;
+    foreach ($options as $value => $caption) {
+        echo '                                <option value ="' . $value . '"' . ($ALBUM_DATA['moderator_group'] == $value ? ' selected': '') . '>' . $caption . "</option>\n";
+    }
+    echo <<<EOT
+                        </select>
+                </td>
+        </tr>
+
+EOT;
+}
 
 function create_form(&$data)
 {
@@ -408,6 +440,9 @@
                 case 7:
                     form_password_hint($element[0],$element[1]);
                     break;
+                case 8 :
+                    form_moderator($element[0], $element[1]);
+                    break;
                 default:
                     cpg_die(CRITICAL_ERROR, 'Invalid action for form creation', __FILE__, __LINE__);
             } // switch
--- include/functions.inc.php.orig	2010-02-08 22:38:00.000000000 +0000
+++ include/functions.inc.php	2010-03-06 10:43:00.000000000 +0000
@@ -922,7 +922,7 @@
 
 function get_pic_data($album, &$count, &$album_name, $limit1=-1, $limit2=-1, $set_caption = true)
 {
-        global $USER, $CONFIG, $ALBUM_SET, $META_ALBUM_SET, $CURRENT_CAT_NAME, $CURRENT_ALBUM_KEYWORD, $HTML_SUBST, $THEME_DIR, $FAVPICS, $FORBIDDEN_SET_DATA;
+        global $USER, $CONFIG, $ALBUM_SET, $META_ALBUM_SET, $CURRENT_CAT_NAME, $CURRENT_ALBUM_KEYWORD, $HTML_SUBST, $THEME_DIR, $FAVPICS, $FORBIDDEN_SET_DATA, $USER_DATA;
         global $album_date_fmt, $lastcom_date_fmt, $lastup_date_fmt, $lasthit_date_fmt, $cat;
         global $lang_get_pic_data, $lang_meta_album_names, $lang_errors;
 
@@ -972,7 +972,11 @@
                   $keyword = '';
                 }
 
-                $approved = GALLERY_ADMIN_MODE ? '' : 'AND approved=\'YES\'';
+                if (is_array($USER_DATA['allowed_albums']) && in_array($album,$USER_DATA['allowed_albums'])) {
+					$approved = '';
+                } else {
+					$approved = GALLERY_ADMIN_MODE ? '' : 'AND approved=\'YES\'';
+				}
 
                 $query = "SELECT COUNT(*) from {$CONFIG['TABLE_PICTURES']} WHERE ((aid='$album' $forbidden_set_string ) $keyword) $approved $ALBUM_SET";
                 $result = cpg_db_query($query);
--- include/init.inc.php.orig	2010-02-08 22:38:00.000000000 +0000
+++ include/init.inc.php	2010-03-06 10:43:00.000000000 +0000
@@ -299,6 +299,15 @@
         if (!$CONFIG['debug_mode']) $cpgdebugger->stop(); // useless to run debugger cos there's no output
         error_reporting(E_PARSE); // hide all errors for visitors
 }
+
+if (!GALLERY_ADMIN_MODE) {
+	$result = cpg_db_query("SELECT DISTINCT(aid) FROM {$CONFIG['TABLE_ALBUMS']} WHERE moderator_group IN ".USER_GROUP_SET);
+	if (mysql_num_rows($result)) {
+		while ($row = mysql_fetch_array($result)) {
+			$USER_DATA['allowed_albums'][] = $row['aid'];
+		}
+	}
+}
 
 // Process theme selection if present in URI or in user profile
 if (!empty($_GET['theme'])) {
--- lang/english_gb.php.orig	2010-02-27 13:11:00.000000000 +0000
+++ lang/english_gb.php	2010-03-06 11:04:00.000000000 +0000
@@ -1401,6 +1401,8 @@
   'edit_files' =>'Edit files', //cpg1.4
   'parent_category' =>'Parent category', //cpg1.4
   'thumbnail_view' =>'Thumbnail view', //cpg1.4
+  'can_moderate' => 'Album can be moderated by', //moderator
+  'none' => 'None', //moderator
 );
 
 // ------------------------------------------------------------------------- //
--- lang/english.php.orig	2010-02-08 22:41:00.000000000 +0000
+++ lang/english.php	2010-03-06 11:34:00.000000000 +0000
@@ -1401,6 +1401,8 @@
   'edit_files' =>'Edit files', //cpg1.4
   'parent_category' =>'Parent category', //cpg1.4
   'thumbnail_view' =>'Thumbnail view', //cpg1.4
+  'can_moderate' => 'Album can be moderated by', //moderator
+  'none' => 'None', //moderator
 );
 
 // ------------------------------------------------------------------------- //
